<?php
if (isset($_POST["btn_submit"])) {
    require_once __DIR__ . "/DataSource.php";
    if (!empty($_POST["original_url"])) {
        $originalURL = urlencode($_POST["original_url"]);
        $shortURL = mt_rand(1000, 9999);

        $query = "INSERT INTO tbl_url (short_url_hash, original_url) VALUES (?, ?)";
        $paramType = "ss";
        $paramValueArray = array($shortURL, $originalURL);

        $ds = new DataSource();
        $ds->insert($query, $paramType, $paramValueArray);
    }
}
?>
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />
    <meta name="description" content="" />
    <meta name="author" content="" />
    <title>URL Shortener PHP Script</title>

    <link href="./assets/css/form.css" rel="stylesheet" />
    <link href="./assets/css/style.css" rel="stylesheet" />
</head>

<body>
    <div class="phppot-container">
        <h1>URL Shortener PHP Script</h1>
        <div class="phppot-message"></div>
        <form id="frm-url-shortener" method="post" onSubmit="return validateLongURL()">
            <div class="row">
                <label>Enter log URL</label>
                <input class="full-width" type="text" name="original_url" id="original_url" placeholder="e.g. http://www.example.com/querystring" autocomplete="off" />
            </div>
            <div class="row">
                <input name="btn_submit" type="submit" value="Shorten the URL" />
            </div>
        </form>
        <?php
        if (!empty($originalURL) && !empty($shortURL)) {
        ?>
            <div class="shortened-url-response">
                <p>
                    <label>Orginal URL:</label>
                    <span id="original_url_response"><?php if ($originalURL) {
                                                            echo urldecode($originalURL);
                                                        } ?></span>
                </p>
                <p>
                    <label>Shortened URL:</label>
                    <?php require_once __DIR__ . "/Config.php"; ?>
                    <span id="shortened_url_response"><?php if ($shortURL) {
                                                            echo Config::ROOT_URL . $shortURL;
                                                        } ?></span>
                </p>
            </div>
        <?php } ?>
    </div>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script>
        function validateLongURL() {
            var valid = true;
            var message = "";
            $('.phppot-message').removeClass('error').html('').hide();
            var originalURL = $('#original_url').val();
            var urlRegexPattern = /^(ftp|http|https):\/\/[^ "]+$/;
            if (originalURL === "") {
                message = 'URL is required.';
                valid = false;
            } else if (!urlRegexPattern.test(originalURL)) {
                message = 'Invalid URL';
                valid = false;
            }

            if(!valid) {
                $('.phppot-message').addClass('error').html(message).show();
            }
            return valid;
        }
    </script>
</body>

</html>